## citus 5.0.1

=== src/backend/distributed/Makefile ===
# Makefile for the Citus extension

citus_subdir = src/backend/distributed
citus_top_builddir = ../../..

MODULE_big = citus
EXTENSION = citus
EXTVERSION = 5.0
DATA_built = $(EXTENSION)--$(EXTVERSION).sql
SCRIPTS = ../../bin/scripts/copy_to_distributed_table

# directories with source files
SUBDIRS = . commands executor master planner relay test utils worker

# That patsubst rule searches all directories listed in SUBDIRS for .c
# files, and adds the corresponding .o files to OBJS
OBJS += \
	$(patsubst $(citus_abs_srcdir)/%.c,%.o,$(foreach dir,$(SUBDIRS), $(wildcard $(citus_abs_srcdir)/$(dir)/*.c)))

# be explicit about the default target
all:

# define build process for latest install file
$(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION).sql
	cat $^ > $@

NO_PGXS = 1

SHLIB_LINK = $(libpq)

include $(citus_top_builddir)/Makefile.global

override CPPFLAGS += -I$(libpq_srcdir)

=== src/test/regress/Makefile ===
# Makefile for tests of the Citus extension

citus_subdir = src/test/regress
citus_top_builddir = ../../..

include $(citus_top_builddir)/Makefile.global

# ensure MAJORVERSION is defined (missing in older versions)
ifndef MAJORVERSION
MAJORVERSION := $(basename $(VERSION))
endif

##
## Citus regression support
##
MULTI_INSTALLDIR=$(CURDIR)/tmp_check/install
pg_regress_multi_check = $(PERL) $(citus_abs_srcdir)/pg_regress_multi.pl --pgxsdir="$(pgxsdir)" --bindir="$(bindir)" --libdir="$(libdir)" --majorversion="$(MAJORVERSION)"
MULTI_REGRESS_OPTS = --inputdir=$(citus_abs_srcdir) $(pg_regress_locale_flags)

# XXX: Can't actually do useful testruns against install - $libdir
# etc will point to the directory configured during postgres'
# build. We could copy the installed tree around, but that's quite
# likely to be mixed with other binaries and such...
cleandir-main:
###	echo rm -rf '$(CURDIR)'/tmp_check/install
###
tempinstall-main: cleandir-main
####	mkdir -p $(MULTI_INSTALLDIR)
###	$(MAKE) DESTDIR=$(MULTI_INSTALLDIR) -C $(citus_top_builddir) install > tmp_check/install.log 2>&1

# Test input and expected files.  These are created by pg_regress itself, so we
# don't have a rule to create them.  We do need rules to clean them however.
input_files := $(patsubst $(citus_abs_srcdir)/input/%.source,sql/%.sql, $(wildcard $(citus_abs_srcdir)/input/*.source))
output_files := $(patsubst $(citus_abs_srcdir)/output/%.source,expected/%.out, $(wildcard $(citus_abs_srcdir)/output/*.source))

# have make check actually run all tests, but keep check-full as an
# intermediate, for muscle memory backward compatibility.
check: check-full
# check-full triggers all tests that ought to be run routinely
check-full: check-multi check-multi-task-tracker check-multi-binary check-worker check-multi-fdw

# using pg_regress_multi_check unnecessarily starts up multiple nodes, which isn't needed
# for check-worker. But that's harmless besides a few cycles.
check-worker: all
	$(pg_regress_multi_check) --load-extension=citus \
	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/worker_schedule $(EXTRA_TESTS)

check-multi: all tempinstall-main
	$(pg_regress_multi_check) --load-extension=citus \
	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)

check-multi-fdw: all tempinstall-main
	$(pg_regress_multi_check) --load-extension=citus --load-extension=file_fdw -- \
	$(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_fdw_schedule $(EXTRA_TESTS)

check-multi-hll: all tempinstall-main
	$(pg_regress_multi_check) --load-extension=citus --load-extension=hll -- \
	$(MULTI_REGRESS_OPTS) $(EXTRA_TESTS) multi_create_table multi_master_protocol multi_stage_data multi_agg_approximate_distinct

check-multi-task-tracker: all tempinstall-main
	$(pg_regress_multi_check) --load-extension=citus \
	--server-option=citus.task_executor_type=task-tracker \
	--server-option=citus.task_tracker_delay=50ms \
	--server-option=citus.large_table_shard_count=1 \
	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)

check-multi-binary: all tempinstall-main
	$(pg_regress_multi_check) --load-extension=citus \
	--server-option=citus.binary_worker_copy_format=on \
	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)

clean distclean maintainer-clean:
	rm -f $(output_files) $(input_files)
	rm -rf tmp_check/

=== debian/changelog ===
citus (5.0.1-1) unstable; urgency=low

  * Fixes issues on 32-bit systems

 -- Jason Petersen <jason@citusdata.com>  Fri, 15 Apr 2016 19:17:35 +0000

citus (5.0.0-1) unstable; urgency=low

  * Initial release

 -- Jason Petersen <jason@citusdata.com>  Thu, 24 Mar 2016 10:12:52 -0400

=== debian/control ===
Source: citus
Section: database
Priority: optional
Maintainer: Jason Petersen <jason@citusdata.com>
Build-Depends: debhelper (>= 9), autotools-dev, flex, postgresql-server-dev-all (>= 158~), libedit-dev, libpam0g-dev, libselinux1-dev, libxslt1-dev
Standards-Version: 3.9.7
Homepage: https://github.com/citusdata/citus
XS-Testsuite: autopkgtest

Package: postgresql-9.5-citus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.5
Description: sharding and distributed joins for PostgreSQL
 Citus is a distributed database implemented as a PostgreSQL extension. It
 provides functions to easily split a PostgreSQL table into shards to be
 placed on remote worker nodes. Citus can replicate shards, update their
 schemas, and keep track of shard health. An advanced distributed planner
 is included which handles queries and modifications against sharded tables.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/postgresql-common/pgxs_debian_control.mk

override_dh_auto_build:
	+pg_buildext build build-%v

override_dh_auto_clean:
	+pg_buildext clean build-%v

override_dh_auto_test:
	# nothing to do here, see debian/tests/* instead

override_dh_auto_configure:
	+pg_buildext configure build-%v

override_dh_auto_install:
	+pg_buildext install build-%v postgresql-%v-citus

	# Install alternatives for our binaries. Could simply link to pg_wrapper,
	# but there's no harm in just using the binary installed with the latest
	# version. Below inspired by a similar block in pg_repack's installer.
	set -ex; \
	binaries="csql copy_to_distributed_table"; \
	for v in $(shell pg_buildext supported-versions); do \
		i=$$(echo $$v | tr -d .); \
		for bin in $$binaries; do \
			echo "update-alternatives --install /usr/bin/$$bin citus-$$bin /usr/lib/postgresql/$$v/bin/$$bin $$i" >> debian/postgresql-$$v-citus.postinst.debhelper; \
			echo "update-alternatives --remove citus-$$bin /usr/lib/postgresql/$$v/bin/$$bin" >> debian/postgresql-$$v-citus.prerm.debhelper; \
		done \
	done

%:
	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/citus-$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/,\
pgpsigurlmangle=s/archive\/v(\d\S*)\.tar\.gz/releases\/download\/v$1\/citus-$1.tar.gz.asc/ \
https://github.com/citusdata/citus/releases /citusdata/citus/archive/v(\d\S*)\.tar\.gz

## citus 5.1.0

=== Makefile ===
# Citus toplevel Makefile

citus_subdir = .
citus_top_builddir = .

# Hint that configure should be run first
ifeq (,$(wildcard Makefile.global))
  $(error ./configure needs to be run before compiling Citus)
endif

include Makefile.global

all: extension csql

# build extension
extension:
	$(MAKE) -C src/backend/distributed/ all
install-extension: extension
	$(MAKE) -C src/backend/distributed/ install
install-headers: extension
	$(MKDIR_P) '$(DESTDIR)$(includedir_server)/distributed/'
# generated headers are located in the build directory
	$(INSTALL_DATA) src/include/citus_config.h '$(DESTDIR)$(includedir_server)/'
# the rest in the source tree
	$(INSTALL_DATA) $(citus_abs_srcdir)/src/include/distributed/*.h '$(DESTDIR)$(includedir_server)/distributed/'
clean-extension:
	$(MAKE) -C src/backend/distributed/ clean
.PHONY: extension install-extension clean-extension
# Add to generic targets
install: install-extension install-headers
clean: clean-extension

# build csql binary
csql:
	$(MAKE) -C src/bin/csql/ all
install-csql: csql
	$(MAKE) -C src/bin/csql/ install
clean-csql:
	$(MAKE) -C src/bin/csql/ clean
.PHONY: csql install-csql clean-csql
# Add to generic targets
install: install-csql
clean: clean-csql

# apply or check style
reindent:
	cd ${citus_abs_top_srcdir} && citus_indent --quiet
check-style:
	cd ${citus_abs_top_srcdir} && citus_indent --quiet --check
.PHONY: reindent check-style

# depend on install for now
check: all install
	$(MAKE) -C src/test/regress check-full

.PHONY: all check install clean

=== src/backend/distributed/Makefile ===
--- 
+++ 
@@ -5,8 +5,13 @@
 
 MODULE_big = citus
 EXTENSION = citus
-EXTVERSION = 5.0
-DATA_built = $(EXTENSION)--$(EXTVERSION).sql
+EXTVERSIONS = 5.0 5.0-1 5.0-2  \
+	5.1-1
+
+# All citus--*.sql files in the source directory
+DATA = $(patsubst $(citus_abs_srcdir)/%.sql,%.sql,$(wildcard $(citus_abs_srcdir)/$(EXTENSION)--*--*.sql))
+# Generated files for each version
+DATA_built = $(foreach v,$(EXTVERSIONS),$(EXTENSION)--$(v).sql)
 SCRIPTS = ../../bin/scripts/copy_to_distributed_table
 
 # directories with source files
@@ -20,8 +25,15 @@
 # be explicit about the default target
 all:
 
-# define build process for latest install file
-$(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION).sql
+# generate each version's file installation file by concatenating
+# previous upgrade scripts
+$(EXTENSION)--5.0.sql: $(EXTENSION).sql
+	cat $^ > $@
+$(EXTENSION)--5.0-1.sql: $(EXTENSION)--5.0.sql $(EXTENSION)--5.0--5.0-1.sql
+	cat $^ > $@
+$(EXTENSION)--5.0-2.sql: $(EXTENSION)--5.0-1.sql $(EXTENSION)--5.0-1--5.0-2.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-1.sql: $(EXTENSION)--5.0-2.sql $(EXTENSION)--5.0-2--5.1-1.sql
 	cat $^ > $@
 
 NO_PGXS = 1

=== src/bin/csql/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin/csql
#
# Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/csql/Makefile
#
#-------------------------------------------------------------------------

citus_subdir = src/bin/csql
citus_top_builddir = ../../..

PROGRAM = csql

PGFILEDESC = "csql - the Citus interactive terminal"
PGAPPICON=win32

OBJS =command.o common.o help.o input.o stringutils.o mainloop.o copy.o \
      copy_options.o stage.o \
      startup.o prompt.o variables.o large_obj.o print.o describe.o \
      tab-complete.o mbprint.o dumputils.o keywords.o kwlookup.o \
      sql_help.o \
      $(WIN32RES)

PG_LIBS = $(libpq)

include $(citus_top_builddir)/Makefile.global

# ensure client includes occur before server
client_includes := $(shell $(PG_CONFIG) --includedir)/internal

override CPPFLAGS := -I$(client_includes) -I$(libpq_srcdir) -I$(citus_abs_top_srcdir)/src/bin/csql $(CPPFLAGS)

# psqlscan is compiled as part of mainloop
mainloop.o: psqlscan.c
psqlscan.c: FLEXFLAGS = -Cfe -p -p
psqlscan.c: FLEX_NO_BACKUP=yes

clean: csql-clean
csql-clean:
	rm -f csql$(X) $(OBJS) psqlscan.c lex.backup

=== debian/changelog ===
citus (5.1.0-1.pgdg80+1) jessie-pgdg; urgency=medium

  * Rebuild for jessie-pgdg (jenkins-citus-source-distribution=jessie-3,
    738fa9adbf20bd4d78ed515bc98b97cc01960bc1/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Tue, 17 May 2016 19:00:37 +0200

citus (5.1.0-1) unstable; urgency=low

  * Adds distributed COPY to rapidly populate distributed tables

  * Adds support for using EXPLAIN on distributed queries

  * Adds multiuser support, including replication of GRANT commands

  * Recognizes and fast-paths single-shard SELECT statements automatically

  * Increases INSERT throughput via shard pruning optimizations

  * Improves planner performance for joins involving tables with many shards

  * Adds ability to pass columns as arguments to function calls in UPDATEs

  * Introduces transaction manager for use by multi-shard commands

  * Adds COUNT(DISTINCT ...) pushdown optimization for hash-partitioned tables

  * Adds support for some UNIQUE indexes on hash- or range-partitioned tables

  * Deprecates \stage in favor of using COPY for append-partition tables

  * Deprecates copy_to_distributed_table in favor of first-class COPY support

  * Fixes build problems when using non-packaged PostgreSQL installs

  * Fixes bug that sometimes skipped pruning when partitioned by VARCHAR column

  * Fixes bug impeding use of user functions in repartitioned subqueries

  * Fixes bug involving queries with equality comparisons of boolean types

  * Fixes crash that prevented use alongside pg_stat_statements

  * Fixes crash arising from SELECT queries that lack a target list

  * Improves warning and error messages

 -- Jason Petersen <jason@citusdata.com>  Tue, 17 May 2016 16:55:02 +0000

## citus 5.1.1

=== src/backend/distributed/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 # That patsubst rule searches all directories listed in SUBDIRS for .c
 # files, and adds the corresponding .o files to OBJS
 OBJS += \
-	$(patsubst $(citus_abs_srcdir)/%.c,%.o,$(foreach dir,$(SUBDIRS), $(wildcard $(citus_abs_srcdir)/$(dir)/*.c)))
+	$(patsubst $(citus_abs_srcdir)/%.c,%.o,$(foreach dir,$(SUBDIRS), $(sort $(wildcard $(citus_abs_srcdir)/$(dir)/*.c))))
 
 # be explicit about the default target
 all:

=== debian/changelog ===
citus (5.1.1-1.pgdg16.04+1) xenial-pgdg; urgency=medium

  * Rebuild for xenial-pgdg (jenkins-citus-source-distribution=xenial-5,
    89570032e4a9224df0f99f7646e27471aff7e23b/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Sun, 19 Jun 2016 06:53:45 +0200

citus (5.1.1-1) unstable; urgency=low

  * Adds complex count distinct expression support in repartitioned subqueries

  * Improves task tracker job cleanup logic, addressing a memory leak

  * Fixes bug that generated incorrect results for LEFT JOIN queries

  * Improves compatibility with Debian's reproducible builds project

  * Fixes build issues on FreeBSD platforms

 -- Jason Petersen <jason@citusdata.com>  Fri, 17 Jun 2016 16:20:15 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,22 @@
 Source: citus
 Section: database
 Priority: optional
-Maintainer: Jason Petersen <jason@citusdata.com>
+Maintainer: Citus Data <packaging@citusdata.com>
+Uploaders: Jason Petersen <jason@citusdata.com>
 Build-Depends: debhelper (>= 9), autotools-dev, flex, postgresql-server-dev-all (>= 158~), libedit-dev, libpam0g-dev, libselinux1-dev, libxslt1-dev
 Standards-Version: 3.9.7
 Homepage: https://github.com/citusdata/citus
 XS-Testsuite: autopkgtest
+
+Package: postgresql-9.4-citus
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.4
+Description: sharding and distributed joins for PostgreSQL
+ Citus is a distributed database implemented as a PostgreSQL extension. It
+ provides functions to easily split a PostgreSQL table into shards to be
+ placed on remote worker nodes. Citus can replicate shards, update their
+ schemas, and keep track of shard health. An advanced distributed planner
+ is included which handles queries and modifications against sharded tables.
 
 Package: postgresql-9.5-citus
 Architecture: any

## citus 5.2.0.PGDG

=== src/backend/distributed/Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 MODULE_big = citus
 EXTENSION = citus
 EXTVERSIONS = 5.0 5.0-1 5.0-2  \
-	5.1-1
+	5.1-1 5.1-2 5.1-3 5.1-4 5.1-5 5.1-6 5.1-7 5.1-8 \
+	5.2-1
 
 # All citus--*.sql files in the source directory
 DATA = $(patsubst $(citus_abs_srcdir)/%.sql,%.sql,$(wildcard $(citus_abs_srcdir)/$(EXTENSION)--*--*.sql))
@@ -15,7 +16,7 @@
 SCRIPTS = ../../bin/scripts/copy_to_distributed_table
 
 # directories with source files
-SUBDIRS = . commands executor master planner relay test utils worker
+SUBDIRS = . commands executor master planner relay test transaction utils worker
 
 # That patsubst rule searches all directories listed in SUBDIRS for .c
 # files, and adds the corresponding .o files to OBJS
@@ -35,7 +36,23 @@
 	cat $^ > $@
 $(EXTENSION)--5.1-1.sql: $(EXTENSION)--5.0-2.sql $(EXTENSION)--5.0-2--5.1-1.sql
 	cat $^ > $@
-
+$(EXTENSION)--5.1-2.sql: $(EXTENSION)--5.1-1.sql $(EXTENSION)--5.1-1--5.1-2.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-3.sql: $(EXTENSION)--5.1-2.sql $(EXTENSION)--5.1-2--5.1-3.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-4.sql: $(EXTENSION)--5.1-3.sql $(EXTENSION)--5.1-3--5.1-4.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-5.sql: $(EXTENSION)--5.1-4.sql $(EXTENSION)--5.1-4--5.1-5.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-6.sql: $(EXTENSION)--5.1-5.sql $(EXTENSION)--5.1-5--5.1-6.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-7.sql: $(EXTENSION)--5.1-6.sql $(EXTENSION)--5.1-6--5.1-7.sql
+	cat $^ > $@
+$(EXTENSION)--5.1-8.sql: $(EXTENSION)--5.1-7.sql $(EXTENSION)--5.1-7--5.1-8.sql
+	cat $^ > $@
+$(EXTENSION)--5.2-1.sql: $(EXTENSION)--5.1-8.sql $(EXTENSION)--5.1-8--5.2-1.sql
+	cat $^ > $@	
+	
 NO_PGXS = 1
 
 SHLIB_LINK = $(libpq)

=== src/bin/csql/Makefile ===
--- 
+++ 
@@ -36,7 +36,9 @@
 # psqlscan is compiled as part of mainloop
 mainloop.o: psqlscan.c
 psqlscan.c: FLEXFLAGS = -Cfe -p -p
-psqlscan.c: FLEX_NO_BACKUP=yes
+
+psqlscan.c: psqlscan.l
+	$(FLEX) $(FLEXFLAGS) -o'$@' $<
 
 clean: csql-clean
 csql-clean:

=== src/test/regress/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 # intermediate, for muscle memory backward compatibility.
 check: check-full
 # check-full triggers all tests that ought to be run routinely
-check-full: check-multi check-multi-task-tracker check-multi-binary check-worker check-multi-fdw
+check-full: check-multi check-multi-task-tracker-extra check-multi-binary check-worker check-multi-fdw
 
 # using pg_regress_multi_check unnecessarily starts up multiple nodes, which isn't needed
 # for check-worker. But that's harmless besides a few cycles.
@@ -57,17 +57,17 @@
 	$(pg_regress_multi_check) --load-extension=citus --load-extension=hll -- \
 	$(MULTI_REGRESS_OPTS) $(EXTRA_TESTS) multi_create_table multi_master_protocol multi_stage_data multi_agg_approximate_distinct
 
-check-multi-task-tracker: all tempinstall-main
+check-multi-task-tracker-extra: all tempinstall-main
 	$(pg_regress_multi_check) --load-extension=citus \
 	--server-option=citus.task_executor_type=task-tracker \
-	--server-option=citus.task_tracker_delay=50ms \
 	--server-option=citus.large_table_shard_count=1 \
-	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)
+	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_task_tracker_extra_schedule $(EXTRA_TESTS)
+
 
 check-multi-binary: all tempinstall-main
 	$(pg_regress_multi_check) --load-extension=citus \
 	--server-option=citus.binary_worker_copy_format=on \
-	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)
+	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_binary_schedule $(EXTRA_TESTS)
 
 clean distclean maintainer-clean:
 	rm -f $(output_files) $(input_files)

=== debian/changelog ===
citus (5.2.0.PGDG-1.pgdg80+1) jessie-pgdg; urgency=medium

  * Rebuild for jessie-pgdg (jenkins-citus-source-distribution=jessie-8,
    d7aba97767afa12b7a64aa3e1ab8c51d23d72456/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Thu, 18 Aug 2016 01:49:50 +0200

citus (5.2.0.PGDG-1) unstable; urgency=low

  * Drops support for PostgreSQL 9.4; PostgreSQL 9.5 is required

  * Adds schema support for tables, named objects (types, operators, etc.)

  * Evaluates non-immutable functions on master in all modification commands

  * Adds support for SERIAL types in non-partition columns

  * Adds support for RETURNING clause in INSERT, UPDATE, and DELETE commands

  * Adds support for multi-statement transactions using a fixed set of nodes

  * Full SQL support for SELECT queries which can be executed on single worker

  * Adds option to perform DDL changes using prepared transactions (2PC)

  * Adds an enable_ddl_propagation parameter to control DDL propagation

  * Accelerates shard pruning during merges

  * Adds master_modify_multiple_shards UDF to modify many shards at once

  * Adds COPY support for arrays of user-defined types

  * Now supports parameterized prepared statements for certain use cases

  * Extends LIMIT/OFFSET support to all executor types

  * Constraint violations now fail fast rather than hitting all placements

  * Makes master_create_empty_shard aware of shard placement policy

  * Reduces unnecessary sleep during queries processed by real-time executor

  * Improves task tracker executor's task cleanup logic

  * Relaxes restrictions on cancellation of DDL commands

  * Removes ONLY keyword from worker SELECT queries

  * Error message improvements and standardization

  * Moves master_update_shard_statistics function to pg_catalog schema

  * Fixes a bug where hash-partitioned anti-joins could return bad results

  * Now sets storage type correctly for foreign table-backed shards

  * Fixes master_update_shard_statistics issue with hash-partitioned tables

  * Fixes an issue related to extending table names that require escaping

  * Reduces risk of row counter overflows during modifications

  * Fixes a crash related to FILTER clause use in COUNT DISTINCT subqueries

  * Fixes crashes related to partition columns with high attribute numbers

  * Fixes certain subquery and join crashes

  * Detects flex for build even if PostgreSQL was built without it

  * Fixes assert-enabled crash when all_modifications_commutative is true

 -- Jason Petersen <jason@citusdata.com>  Wed, 17 Aug 2016 10:23:21 +0000

## citus 5.2.1.PGDG

=== debian/changelog ===
citus (5.2.1.PGDG-1.pgdg80+1) jessie-pgdg; urgency=medium

  * Rebuild for jessie-pgdg (jenkins-citus-source-distribution=jessie-9,
    a0097b771e56d0b04bb194710b4e8a999698361c/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Wed, 07 Sep 2016 19:58:01 +0200

citus (5.2.1.PGDG-1) unstable; urgency=low

  * Fixes subquery pushdown to properly extract outer join qualifiers

  * Addresses possible memory leak during multi-shard transactions

 -- Jason Petersen <jason@citusdata.com>  Tue, 6 Sep 2016 20:47:15 +0000

## citus 6.0.0.PGDG

=== debian/changelog ===
citus (6.0.0.PGDG-1.pgdg80+4) jessie-pgdg; urgency=medium

  * Rebuild for jessie-pgdg (jenkins-citus-source-distribution=jessie-
    13, 63712af5378ba157a5bd9566752b4a3d015b0818/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Sat, 12 Nov 2016 00:37:03 +0100

citus (6.0.0.PGDG-1) unstable; urgency=low

  * Adds compatibility with PostgreSQL 9.6, now the recommended version

  * Removes the pg_worker_list.conf file in favor of a pg_dist_node table

  * Adds master_add_node and master_add_node UDFs to manage membership

  * Removes the \stage command and corresponding csql binary in favor of COPY

  * Removes copy_to_distributed_table in favor of first-class COPY support

  * Adds support for multiple DDL statements within a transaction

  * Adds support for certain foreign key constraints

  * Adds support for parallel INSERT INTO ... SELECT against colocated tables

  * Adds support for the TRUNCATE command

  * Adds support for HAVING clauses in SELECT queries

  * Adds support for EXCLUDE constraints which include the partition column

  * Adds support for system columns in queries (tableoid, ctid, etc.)

  * Adds support for relation name extension within INDEX definitions

  * Adds support for no-op UPDATEs of the partition column

  * Adds several general-purpose utility UDFs to aid in Citus maintenance

  * Adds master_expire_table_cache UDF to forcibly expire cached shards

  * Parallelizes the processing of DDL commands which affect distributed tables

  * Adds support for repartition jobs using composite or custom types

  * Enhances object name extension to handle long names and large shard counts

  * Parallelizes the master_modify_multiple_shards UDF

  * Changes distributed table creation to error if the target table is not empty

  * Changes the pg_dist_shard.logicalrelid column from an oid to regclass

  * Adds a placementid column to pg_dist_shard_placement, replacing Oid use

  * Removes the pg_dist_shard.shardalias distribution metadata column

  * Adds pg_dist_partition.repmodel to track tables using streaming replication

  * Adds internal infrastructure to take snapshots of distribution metadata

  * Addresses the need to invalidate prepared statements on metadata changes

  * Adds a mark_tables_colocated UDF for denoting pre-6.0 manual colocation

  * Fixes a bug affecting prepared statement execution within PL/pgSQL

  * Fixes a bug affecting COPY commands using composite types

  * Fixes a bug that could cause crashes during EXPLAIN EXECUTE

  * Separates worker and master job temporary folders

  * Eliminates race condition between distributed modification and repair

  * Relaxes the requirement that shard repairs also repair colocated shards

  * Implements internal functions to track which tables' shards are colocated

  * Adds pg_dist_partition.colocationid to track colocation group membership

  * Extends shard copy and move operations to respect colocation settings

  * Adds pg_dist_local_group to prepare for future MX-related changes

  * Adds create_distributed_table to easily create shards and infer colocation

 -- Jason Petersen <jason@citusdata.com>  Tue, 8 Nov 2016 19:45:45 +0000

citus (5.2.2.PGDG-1) unstable; urgency=low

  * Adds support for IF NOT EXISTS clause of CREATE INDEX command

  * Adds support for RETURN QUERY and FOR ... IN PL/pgSQL features

  * Extends the router planner to handle more queries

  * Changes COUNT of zero-row sets to return 0 rather than an empty result

  * Reduces the minimum permitted task_tracker_delay to a single millisecond

  * Fixes a bug that caused crashes during joins with a WHERE false clause

  * Fixes a bug triggered by unique violation errors raised in long transactions

  * Fixes a bug resulting in multiple registration of transaction callbacks

  * Fixes a bug which could result in stale reads of distribution metadata

  * Fixes a bug preventing distributed modifications in some PL/pgSQL functions

  * Fixes some code paths that could hypothetically read uninitialized memory

  * Lowers log level of "waiting for activity" messages

 -- Jason Petersen <jason@citusdata.com>  Tue, 8 Nov 2016 18:43:37 +0000

## citus 6.0.1.PGDG

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 include Makefile.global
 
-all: extension csql
+all: extension
 
 # build extension
 extension:
@@ -30,18 +30,6 @@
 install: install-extension install-headers
 clean: clean-extension
 
-# build csql binary
-csql:
-	$(MAKE) -C src/bin/csql/ all
-install-csql: csql
-	$(MAKE) -C src/bin/csql/ install
-clean-csql:
-	$(MAKE) -C src/bin/csql/ clean
-.PHONY: csql install-csql clean-csql
-# Add to generic targets
-install: install-csql
-clean: clean-csql
-
 # apply or check style
 reindent:
 	cd ${citus_abs_top_srcdir} && citus_indent --quiet

=== src/backend/distributed/Makefile ===
--- 
+++ 
@@ -7,16 +7,16 @@
 EXTENSION = citus
 EXTVERSIONS = 5.0 5.0-1 5.0-2  \
 	5.1-1 5.1-2 5.1-3 5.1-4 5.1-5 5.1-6 5.1-7 5.1-8 \
-	5.2-1
+	5.2-1 5.2-2 5.2-3 5.2-4 \
+	6.0-1 6.0-2 6.0-3 6.0-4 6.0-5 6.0-6 6.0-7 6.0-8 6.0-9 6.0-10 6.0-11 6.0-12 6.0-13 6.0-14 6.0-15 6.0-16 6.0-17 6.0-18
 
 # All citus--*.sql files in the source directory
 DATA = $(patsubst $(citus_abs_srcdir)/%.sql,%.sql,$(wildcard $(citus_abs_srcdir)/$(EXTENSION)--*--*.sql))
 # Generated files for each version
 DATA_built = $(foreach v,$(EXTVERSIONS),$(EXTENSION)--$(v).sql)
-SCRIPTS = ../../bin/scripts/copy_to_distributed_table
 
 # directories with source files
-SUBDIRS = . commands executor master planner relay test transaction utils worker
+SUBDIRS = . commands executor master metadata planner relay test transaction utils worker
 
 # That patsubst rule searches all directories listed in SUBDIRS for .c
 # files, and adds the corresponding .o files to OBJS
@@ -51,8 +51,50 @@
 $(EXTENSION)--5.1-8.sql: $(EXTENSION)--5.1-7.sql $(EXTENSION)--5.1-7--5.1-8.sql
 	cat $^ > $@
 $(EXTENSION)--5.2-1.sql: $(EXTENSION)--5.1-8.sql $(EXTENSION)--5.1-8--5.2-1.sql
-	cat $^ > $@	
-	
+	cat $^ > $@
+$(EXTENSION)--5.2-2.sql: $(EXTENSION)--5.2-1.sql $(EXTENSION)--5.2-1--5.2-2.sql
+	cat $^ > $@
+$(EXTENSION)--5.2-3.sql: $(EXTENSION)--5.2-2.sql $(EXTENSION)--5.2-2--5.2-3.sql
+	cat $^ > $@
+$(EXTENSION)--5.2-4.sql: $(EXTENSION)--5.2-3.sql $(EXTENSION)--5.2-3--5.2-4.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-1.sql: $(EXTENSION)--5.2-4.sql $(EXTENSION)--5.2-4--6.0-1.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-2.sql: $(EXTENSION)--6.0-1.sql $(EXTENSION)--6.0-1--6.0-2.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-3.sql: $(EXTENSION)--6.0-2.sql $(EXTENSION)--6.0-2--6.0-3.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-4.sql: $(EXTENSION)--6.0-3.sql $(EXTENSION)--6.0-3--6.0-4.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-5.sql: $(EXTENSION)--6.0-4.sql $(EXTENSION)--6.0-4--6.0-5.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-6.sql: $(EXTENSION)--6.0-5.sql $(EXTENSION)--6.0-5--6.0-6.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-7.sql: $(EXTENSION)--6.0-6.sql $(EXTENSION)--6.0-6--6.0-7.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-8.sql: $(EXTENSION)--6.0-7.sql $(EXTENSION)--6.0-7--6.0-8.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-9.sql: $(EXTENSION)--6.0-8.sql $(EXTENSION)--6.0-8--6.0-9.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-10.sql: $(EXTENSION)--6.0-9.sql $(EXTENSION)--6.0-9--6.0-10.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-11.sql: $(EXTENSION)--6.0-10.sql $(EXTENSION)--6.0-10--6.0-11.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-12.sql: $(EXTENSION)--6.0-11.sql $(EXTENSION)--6.0-11--6.0-12.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-13.sql: $(EXTENSION)--6.0-12.sql $(EXTENSION)--6.0-12--6.0-13.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-14.sql: $(EXTENSION)--6.0-13.sql $(EXTENSION)--6.0-13--6.0-14.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-15.sql: $(EXTENSION)--6.0-14.sql $(EXTENSION)--6.0-14--6.0-15.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-16.sql: $(EXTENSION)--6.0-15.sql $(EXTENSION)--6.0-15--6.0-16.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-17.sql: $(EXTENSION)--6.0-16.sql $(EXTENSION)--6.0-16--6.0-17.sql
+	cat $^ > $@
+$(EXTENSION)--6.0-18.sql: $(EXTENSION)--6.0-17.sql $(EXTENSION)--6.0-17--6.0-18.sql
+	cat $^ > $@
+
 NO_PGXS = 1
 
 SHLIB_LINK = $(libpq)

=== src/test/regress/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 ## Citus regression support
 ##
 MULTI_INSTALLDIR=$(CURDIR)/tmp_check/install
-pg_regress_multi_check = $(PERL) $(citus_abs_srcdir)/pg_regress_multi.pl --pgxsdir="$(pgxsdir)" --bindir="$(bindir)" --libdir="$(libdir)" --majorversion="$(MAJORVERSION)"
+pg_regress_multi_check = $(PERL) $(citus_abs_srcdir)/pg_regress_multi.pl --pgxsdir="$(pgxsdir)" --bindir="$(bindir)" --libdir="$(libdir)" --majorversion="$(MAJORVERSION)" --postgres-builddir="$(postgres_abs_builddir)"  --postgres-srcdir="$(postgres_abs_srcdir)"
 MULTI_REGRESS_OPTS = --inputdir=$(citus_abs_srcdir) $(pg_regress_locale_flags)
 
 # XXX: Can't actually do useful testruns against install - $libdir
@@ -37,7 +37,7 @@
 # intermediate, for muscle memory backward compatibility.
 check: check-full
 # check-full triggers all tests that ought to be run routinely
-check-full: check-multi check-multi-task-tracker-extra check-multi-binary check-worker check-multi-fdw
+check-full: check-multi check-multi-task-tracker-extra check-multi-binary check-worker
 
 # using pg_regress_multi_check unnecessarily starts up multiple nodes, which isn't needed
 # for check-worker. But that's harmless besides a few cycles.
@@ -49,13 +49,9 @@
 	$(pg_regress_multi_check) --load-extension=citus \
 	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)
 
-check-multi-fdw: all tempinstall-main
-	$(pg_regress_multi_check) --load-extension=citus --load-extension=file_fdw -- \
-	$(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_fdw_schedule $(EXTRA_TESTS)
-
-check-multi-hll: all tempinstall-main
-	$(pg_regress_multi_check) --load-extension=citus --load-extension=hll -- \
-	$(MULTI_REGRESS_OPTS) $(EXTRA_TESTS) multi_create_table multi_master_protocol multi_stage_data multi_agg_approximate_distinct
+check-isolation: all tempinstall-main
+	$(pg_regress_multi_check) --load-extension=citus --isolationtester \
+	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/isolation_schedule $(EXTRA_TESTS)
 
 check-multi-task-tracker-extra: all tempinstall-main
 	$(pg_regress_multi_check) --load-extension=citus \

=== debian/changelog ===
citus (6.0.1.PGDG-1) unstable; urgency=low

  * Fixes a bug causing failures during pg_upgrade

  * Fixes a bug preventing DML queries during colocated table creation

  * Fixes a bug that caused NULL parameters to be incorrectly passed as text

 -- Burak Yucesoy <burak@citusdata.com>  Wed, 30 Nov 2016 15:27:38 +0000

=== debian/control ===
Source: citus
Section: database
Priority: optional
Maintainer: Citus Data <packaging@citusdata.com>
Uploaders: Jason Petersen <jason@citusdata.com>
Build-Depends: debhelper (>= 9), autotools-dev, postgresql-server-dev-all (>= 158~), libedit-dev, libpam0g-dev, libselinux1-dev, libxslt1-dev, libssl-dev, libkrb5-dev
Standards-Version: 3.9.7
Homepage: https://github.com/citusdata/citus
XS-Testsuite: autopkgtest

Package: postgresql-9.6-citus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.6
Description: sharding and distributed joins for PostgreSQL
 Citus is a distributed database implemented as a PostgreSQL extension. It
 provides functions to easily split a PostgreSQL table into shards to be
 placed on remote worker nodes. Citus can replicate shards, update their
 schemas, and keep track of shard health. An advanced distributed planner
 is included which handles queries and modifications against sharded tables.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/postgresql-common/pgxs_debian_control.mk

override_dh_auto_build:
	+pg_buildext build build-%v

override_dh_auto_clean:
	+pg_buildext clean build-%v

override_dh_auto_test:
	# nothing to do here, see debian/tests/* instead

override_dh_auto_configure:
	+pg_buildext configure build-%v

override_dh_auto_install:
	+pg_buildext install build-%v postgresql-%v-citus

%:
	dh $@

## citus 6.2.1.PGDG

=== debian/changelog ===
citus (6.2.1.PGDG-1.pgdg80+1) jessie-pgdg; urgency=medium

  * Rebuild for jessie-pgdg (jenkins-citus-source-distribution=jessie-
    17, d153411de78b50a462497cc3c38857e2c9914dee/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Thu, 25 May 2017 19:25:52 +0200

citus (6.2.1.PGDG-1) unstable; urgency=low

  * Relaxes version-check logic to avoid breaking non-distributed commands

  * Increases SQL subquery coverage by pushing down more kinds of queries

  * Adds CustomScan API support to allow read-only transactions

  * Adds support for CREATE/DROP INDEX CONCURRENTLY

  * Adds support for ALTER TABLE ... ADD CONSTRAINT

  * Adds support for ALTER TABLE ... RENAME COLUMN

  * Adds support for DISABLE/ENABLE TRIGGER ALL

  * Adds support for expressions in the partition column in INSERTs

  * Adds support for query parameters in combination with function evaluation

  * Adds support for creating distributed tables from non-empty local tables

  * Adds UDFs to get size of distributed tables

  * Adds UDFs to add a new node without replicating reference tables

  * Adds checks to prevent running Citus binaries with wrong metadata tables

  * Improves shard pruning performance for range queries

  * Improves planner performance for joins involving co-located tables

  * Improves shard copy performance by creating indexes after copy

  * Improves task-tracker performance by batching several status checks

  * Enables router planner for queries on range partitioned table

  * Changes TRUNCATE to drop local data only if enable_ddl_propagation is off

  * Starts to execute DDL on coordinator before workers

  * Fixes a bug causing incorrectly reading invalidated cache

  * Fixes a bug related to creation of schemas of in workers with incorrect owner

  * Fixes a bug related to concurrent run of shard drop functions

  * Fixes a bug related to EXPLAIN ANALYZE with DML queries

  * Fixes a bug related to SQL functions in FROM clause

  * Adds a GUC variable to report cross shard queries

  * Fixes a bug related to partition columns without native hash function

  * Adds internal infrastructures and tests to improve development process

  * Addresses various race conditions and deadlocks

  * Improves and standardizes error messages

 -- Jason Petersen <jason@citusdata.com>  Thu, 25 May 2017 17:08:07 +0000

## citus 6.2.2.PGDG

=== src/backend/distributed/Makefile ===
--- 
+++ 
@@ -8,7 +8,9 @@
 EXTVERSIONS = 5.0 5.0-1 5.0-2  \
 	5.1-1 5.1-2 5.1-3 5.1-4 5.1-5 5.1-6 5.1-7 5.1-8 \
 	5.2-1 5.2-2 5.2-3 5.2-4 \
-	6.0-1 6.0-2 6.0-3 6.0-4 6.0-5 6.0-6 6.0-7 6.0-8 6.0-9 6.0-10 6.0-11 6.0-12 6.0-13 6.0-14 6.0-15 6.0-16 6.0-17 6.0-18
+	6.0-1 6.0-2 6.0-3 6.0-4 6.0-5 6.0-6 6.0-7 6.0-8 6.0-9 6.0-10 6.0-11 6.0-12 6.0-13 6.0-14 6.0-15 6.0-16 6.0-17 6.0-18 \
+	6.1-1 6.1-2 6.1-3 6.1-4 6.1-5 6.1-6 6.1-7 6.1-8 6.1-9 6.1-10 6.1-11 6.1-12 6.1-13 6.1-14 6.1-15 6.1-16 6.1-17 \
+	6.2-1 6.2-2 6.2-3 6.2-4
 
 # All citus--*.sql files in the source directory
 DATA = $(patsubst $(citus_abs_srcdir)/%.sql,%.sql,$(wildcard $(citus_abs_srcdir)/$(EXTENSION)--*--*.sql))
@@ -16,7 +18,7 @@
 DATA_built = $(foreach v,$(EXTVERSIONS),$(EXTENSION)--$(v).sql)
 
 # directories with source files
-SUBDIRS = . commands executor master metadata planner relay test transaction utils worker
+SUBDIRS = . commands connection executor master metadata planner relay test transaction utils worker
 
 # That patsubst rule searches all directories listed in SUBDIRS for .c
 # files, and adds the corresponding .o files to OBJS
@@ -94,6 +96,48 @@
 	cat $^ > $@
 $(EXTENSION)--6.0-18.sql: $(EXTENSION)--6.0-17.sql $(EXTENSION)--6.0-17--6.0-18.sql
 	cat $^ > $@
+$(EXTENSION)--6.1-1.sql: $(EXTENSION)--6.0-18.sql $(EXTENSION)--6.0-18--6.1-1.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-2.sql: $(EXTENSION)--6.1-1.sql $(EXTENSION)--6.1-1--6.1-2.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-3.sql: $(EXTENSION)--6.1-2.sql $(EXTENSION)--6.1-2--6.1-3.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-4.sql: $(EXTENSION)--6.1-3.sql $(EXTENSION)--6.1-3--6.1-4.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-5.sql: $(EXTENSION)--6.1-4.sql $(EXTENSION)--6.1-4--6.1-5.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-6.sql: $(EXTENSION)--6.1-5.sql $(EXTENSION)--6.1-5--6.1-6.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-7.sql: $(EXTENSION)--6.1-6.sql $(EXTENSION)--6.1-6--6.1-7.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-8.sql: $(EXTENSION)--6.1-7.sql $(EXTENSION)--6.1-7--6.1-8.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-9.sql: $(EXTENSION)--6.1-8.sql $(EXTENSION)--6.1-8--6.1-9.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-10.sql: $(EXTENSION)--6.1-9.sql $(EXTENSION)--6.1-9--6.1-10.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-11.sql: $(EXTENSION)--6.1-10.sql $(EXTENSION)--6.1-10--6.1-11.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-12.sql: $(EXTENSION)--6.1-11.sql $(EXTENSION)--6.1-11--6.1-12.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-13.sql: $(EXTENSION)--6.1-12.sql $(EXTENSION)--6.1-12--6.1-13.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-14.sql: $(EXTENSION)--6.1-13.sql $(EXTENSION)--6.1-13--6.1-14.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-15.sql: $(EXTENSION)--6.1-14.sql $(EXTENSION)--6.1-14--6.1-15.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-16.sql: $(EXTENSION)--6.1-15.sql $(EXTENSION)--6.1-15--6.1-16.sql
+	cat $^ > $@
+$(EXTENSION)--6.1-17.sql: $(EXTENSION)--6.1-16.sql $(EXTENSION)--6.1-16--6.1-17.sql
+	cat $^ > $@
+$(EXTENSION)--6.2-1.sql: $(EXTENSION)--6.1-17.sql $(EXTENSION)--6.1-17--6.2-1.sql
+	cat $^ > $@
+$(EXTENSION)--6.2-2.sql: $(EXTENSION)--6.2-1.sql $(EXTENSION)--6.2-1--6.2-2.sql
+	cat $^ > $@
+$(EXTENSION)--6.2-3.sql: $(EXTENSION)--6.2-2.sql $(EXTENSION)--6.2-2--6.2-3.sql
+	cat $^ > $@
+$(EXTENSION)--6.2-4.sql: $(EXTENSION)--6.2-3.sql $(EXTENSION)--6.2-3--6.2-4.sql
+	cat $^ > $@
 
 NO_PGXS = 1

=== src/test/regress/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 # intermediate, for muscle memory backward compatibility.
 check: check-full
 # check-full triggers all tests that ought to be run routinely
-check-full: check-multi check-multi-task-tracker-extra check-multi-binary check-worker
+check-full: check-multi check-multi-mx check-multi-task-tracker-extra check-multi-binary check-worker
 
 # using pg_regress_multi_check unnecessarily starts up multiple nodes, which isn't needed
 # for check-worker. But that's harmless besides a few cycles.
@@ -49,16 +49,27 @@
 	$(pg_regress_multi_check) --load-extension=citus \
 	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)
 
+check-multi-vg: all tempinstall-main
+	$(pg_regress_multi_check) --load-extension=citus --valgrind \
+	--pg_ctl-timeout=360 --connection-timeout=500000 --valgrind-path=valgrind --valgrind-log-file=$(VALGRIND_LOG_FILE) \
+	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_schedule $(EXTRA_TESTS)
+
 check-isolation: all tempinstall-main
 	$(pg_regress_multi_check) --load-extension=citus --isolationtester \
 	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/isolation_schedule $(EXTRA_TESTS)
+
+check-vanilla: all tempinstall-main
+	$(pg_regress_multi_check) --load-extension=citus --vanillatest
+	
+check-multi-mx: all tempinstall-main
+	$(pg_regress_multi_check) --load-extension=citus \
+	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_mx_schedule $(EXTRA_TESTS)
 
 check-multi-task-tracker-extra: all tempinstall-main
 	$(pg_regress_multi_check) --load-extension=citus \
 	--server-option=citus.task_executor_type=task-tracker \
 	--server-option=citus.large_table_shard_count=1 \
 	-- $(MULTI_REGRESS_OPTS) --schedule=$(citus_abs_srcdir)/multi_task_tracker_extra_schedule $(EXTRA_TESTS)
-
 
 check-multi-binary: all tempinstall-main
 	$(pg_regress_multi_check) --load-extension=citus \

=== debian/changelog ===
citus (6.2.2.PGDG-1.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg (jenkins-citus-source-distribution=stretch-
    18, 70c4ba2a3e46d7f34784d1b92e3c146675331f83/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Thu, 08 Jun 2017 00:10:39 +0200

citus (6.2.2.PGDG-1) unstable; urgency=low

  * Fixes a common cause of deadlocks when repairing tables with foreign keys

 -- Burak Velioglu <velioglub@citusdata.com>  Wed, 07 Jun 2017 09:42:17 +0000

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,16 @@
 Standards-Version: 3.9.7
 Homepage: https://github.com/citusdata/citus
 XS-Testsuite: autopkgtest
+
+Package: postgresql-9.5-citus
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.5
+Description: sharding and distributed joins for PostgreSQL
+ Citus is a distributed database implemented as a PostgreSQL extension. It
+ provides functions to easily split a PostgreSQL table into shards to be
+ placed on remote worker nodes. Citus can replicate shards, update their
+ schemas, and keep track of shard health. An advanced distributed planner
+ is included which handles queries and modifications against sharded tables.
 
 Package: postgresql-9.6-citus
 Architecture: any

## citus 7.0.1.PGDG

=== debian/changelog ===
citus (7.0.1.PGDG-1.pgdg80+1) jessie-pgdg; urgency=medium

  * Rebuild for jessie-pgdg (jenkins-citus-source-distribution=jessie-
    20, 5eec50ba0c13e44e221e93b4c5807d09cc1c7a62/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Wed, 13 Sep 2017 04:17:47 +0200

citus (7.0.1.PGDG-1) unstable; urgency=low

  * Fixes a bug that could cause memory leaks in INSERT ... SELECT queries

  * Fixes a bug that could cause incorrect execution of prepared statements

  * Fixes a bug that could cause excessive memory usage during COPY

  * Incorporates latest changes from core PostgreSQL code

 -- Burak Yucesoy <burak@citusdata.com>  Tue, 12 Sep 2017 17:53:50 +0000

citus (7.0.0.PGDG-1) unstable; urgency=low

  * Adds support for PostgreSQL 10

  * Drops support for PostgreSQL 9.5

  * Adds support for multi-row INSERT

  * Adds support for router UPDATE and DELETE queries with subqueries

  * Adds infrastructure for distributed deadlock detection

  * Deprecates enable_deadlock_prevention flag

  * Adds support for partitioned tables

  * Adds support for creating UNLOGGED tables

  * Adds support for SAVEPOINT

  * Adds UDF citus_create_restore_point for taking distributed snapshots

  * Adds support for evaluating non-pushable INSERT ... SELECT queries

  * Adds support for subquery pushdown on reference tables

  * Adds shard pruning support for IN and ANY

  * Adds support for UPDATE and DELETE commands that prune down to 0 shard

  * Enhances transaction support by relaxing some transaction restrictions

  * Fixes a bug causing crash if distributed table has no shards

  * Fixes a bug causing crash when removing inactive node

  * Fixes a bug causing failure during COPY on tables with dropped columns

  * Fixes a bug causing failure during DROP EXTENSION

  * Fixes a bug preventing executing VACUUM and INSERT concurrently

  * Fixes a bug in prepared INSERT statements containing an implicit cast

  * Fixes several issues related to statement cancellations and connections

  * Fixes several 2PC related issues

  * Removes an unnecessary dependency causing warning messages in pg_dump

  * Adds internal infrastructure for follower clusters

  * Adds internal infrastructure for progress tracking

  * Implements various performance improvements

  * Adds internal infrastructures and tests to improve development process

  * Addresses various race conditions and deadlocks

  * Improves and standardizes error messages

 -- Burak Yucesoy <burak@citusdata.com>  Wed, 30 Aug 2017 12:27:53 +0000

## citus 7.0.2.PGDG

=== debian/changelog ===
citus (7.0.2.PGDG-2.pgdg+1) sid-pgdg; urgency=medium

  * Rebuild for sid-pgdg (jenkins-citus-source-distribution=sid-25,
    50f6b1c6ad12b2ceb61e80bf60b49cd384be00b9/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Fri, 06 Oct 2017 01:25:20 +0200

citus (7.0.2.PGDG-2) unstable; urgency=low

  * Rebuild for PostgreSQL 10 compatibility

 -- Jason Petersen <jason@citusdata.com>  Thu, 5 Oct 2017 17:24:19 +0000

citus (7.0.2.PGDG-1) unstable; urgency=low

  * Updates task-tracker to limit file access

 -- Burak Yucesoy <burak@citusdata.com>  Thu, 28 Sep 2017 22:29:01 +0000

=== debian/control ===
Source: citus
Section: database
Priority: optional
Maintainer: Citus Data <packaging@citusdata.com>
Uploaders: Jason Petersen <jason@citusdata.com>
Build-Depends: debhelper (>= 9), autotools-dev, postgresql-server-dev-all (>= 158~), libedit-dev, libpam0g-dev, libselinux1-dev, libxslt1-dev, libssl-dev, libkrb5-dev, libicu-dev
Standards-Version: 3.9.7
Homepage: https://github.com/citusdata/citus
XS-Testsuite: autopkgtest

Package: postgresql-9.6-citus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.6
Description: sharding and distributed joins for PostgreSQL
 Citus is a distributed database implemented as a PostgreSQL extension. It
 provides functions to easily split a PostgreSQL table into shards to be
 placed on remote worker nodes. Citus can replicate shards, update their
 schemas, and keep track of shard health. An advanced distributed planner
 is included which handles queries and modifications against sharded tables.
